
 ;
 ; IMPORTANT:    YOU ARE USING THIS SOFTWARE AT YOUR OWN RISK.
 ;               BEFORE USING THIS SOFTWARE READ THE FILE 'DISCLAIM.TXT'.
 ;

 ;
 ; SBRESET - Resets the MIDI port of a sound card to encounter the 
 ; 'display freeze' problem on modern MIDI synthesizers (e.g. SY99)
 ;
 ; However, if 220hex is not the base address of your sound card, you'll
 ; have to change the following address:
 ;
 
 Port equ 0220h

 ;
 ; change into values between 0200h and 0260h
 ;


 assume cs:code, ds:code, es:code, ss:code

 org 100h

 jmp near ResetDsp

 Delay proc near          ; quick and dirty delay method
  push cx
  mov cx,0FFFFh
  @L1:
  dec cx
  cmp cx,0
  jne @L1
  pop cx
  ret
 Delay endp


 ResetDsp:
   mov dx,Port                ; write reset command
   add dx,6
   xor ax,ax
   inc al
   out dx,al
   
   call delay                    ; wait for SB to work...

   xor ax,ax                     ; write additional reset command
   out dx,ax   
 
   mov cx,100                    ; try 100 times to read 'ready' flag
  @L2:
   dec cx
   mov dx,Port
   add dx,0Eh
   in al,dx
   sub dx,4
   in al,dx
   cmp cx,0
   je Failed 
   
   cmp al,0AAh
   je ResetOk
   jmp @L2


 Failed:                         ; No sound card at 220hex

 mov dx,offset FailedMsg
 mov ah,09h
 int 21h
 mov ax,04C01h
 int 21h


 ResetOk:

 mov cx,100    ; loop 100 times
 @L3:
 dec cx
 cmp cx,0
 je @L4
 mov dx,Port   ; set DIRECT READ mode
 add dx,0Ch    ; this will flush MIDI IN FIFO
 mov ax,30h

 call delay    ; wait for SB to work...

 out dx,ax     ; set DIRECT WRITE mode
 mov ax,38h    ; this will quit 'hanging' commands in MIDI OUT queue
 out dx,ax

 call delay    ; wait another moment...
 jmp @L3


 @L4:
 mov ax,04C00h   ; there we go -> back to DOS
 int 21h

 ;
 ; The following string is written to the screen if there were problems
 ; resetting the MIDI port. However, SBRESET >NUL will not output anything
 ; on the screen. Do NOT remove the "$" sign.
 ;

 FailedMsg db 0d,0a,"SBRESET --- Failed to reset MIDI port...",0d,0a,7,"$"

